CREATE OR ALTER procedure APPENDFFIOVPROC (
    V_SHFIOV char(10),
    V_ID_REPORT integer,
    V_FIOVI char(20),
    V_GRYPP char(1),
    V_SPEZ char(3),
    V_PR integer,
    V_V14 char(15),
    V_V15 char(9),
    V_RMIS char(10),
    V_PRVS char(6))
as
BEGIN
    if (exists (select SHFIOV, ID_REPORT from FFIOV where ID_REPORT = :v_ID_REPORT and SHFIOV = :v_SHFIOV)) then
    UPDATE FFIOV
       SET FIOVI          = :v_FIOVI,
           GRYPP          = :v_GRYPP,
           SPEZ           = :v_SPEZ,
           PR             = :v_pr,
           K_V14          = :v_v14,
           K_V15          = :v_v15,
           K_RMIS         = :v_rmis,
           PRVS           = :v_prvs
     WHERE SHFIOV    = :v_SHFIOV
       AND ID_REPORT = :v_ID_REPORT;
    else
    begin
        if (exists (select id_report from report where id_report = :v_id_report)
            and exists (select sh_st from spez2006 where sh_st = :v_spez)) then
        begin
            INSERT INTO FFIOV(SHFIOV,
                              ID_REPORT,
                              FIOVI,
                              GRYPP,
                              SPEZ,
                              PR,
                              K_V14,
                              K_V15,
                              K_RMIS,
                              PRVS)
            VALUES(:v_SHFIOV,
                   :v_ID_REPORT,
                   :v_FIOVI,
                   :v_GRYPP,
                   :v_SPEZ,
                   :v_pr,
                   :v_v14,
                   :v_v15,
                   :v_rmis,
                   :v_prvs);
        end
    end
END
